Attribute VB_Name = "modSubClass"
'******************************************************************************************
'     Sample for subclassing a foreign application by use of the "dssubcls.dll"
'
'******************************************************************************************
Option Explicit
'******************************************************************************************
'# This function is called from the DLL passing the parameters of the original messages,
'# but NOT for messages below WM_USER which use pointers.
'# To get all messages, you must call "UseSendMessage 1".
'# To be able to suppress or modify messages, you must call "UseSendMessage 1" first.
Public Function Callback&(ByVal wMsg&, ByVal wParam&, ByVal lParam&)
  
        '# Display the message from Excel
        If wMsg = WM_SETCURSOR Or wMsg = WM_MOUSEMOVE Or wMsg = WM_NCHITTEST _
        Or wMsg = WM_CTLCOLORSCROLLBAR Or wMsg = WM_PAINT Or wMsg = WM_ERASEBKGND _
        Or wMsg = WM_NCPAINT Or wMsg = WM_ACTIVATEAPP Then
            'Do Nothing
        Else
            Call Form1.DisplayMessage(wMsg)
            Debug.Print Hex(wMsg)
        End If
  
  
  Select Case wMsg
        '-------------------------------------------------------------------
        '# These calls disable the system menu and menu functions of Excel
        Case WM_CLOSE:
            Call SetParams             '# = suppress message
        Case WM_COMMAND:
            Call SetParams             '# = suppress message
        Case WM_SYSCOMMAND:
            Call SetParams             '# = suppress message
'        Case WM_WM_SETCURSOR:
'            Call SetParams             '# = suppress message
'        Case WM_NCHITTEST:
'            Call SetParams             '# = suppress message
'        Case WM_MOUSEFIRST:
'            Call SetParams             '# = suppress message
'        Case WM_MOUSEMOVE:
'            Call SetParams             '# = suppress message
        '-------------------------------------------------------------------
        '# Display the text written in Excel
        Case WM_CHAR:
            Call Form1.DisplayText(wParam)
            Debug.Print wParam
        '-------------------------------------------------------------------
        '# Code for evaluating messages in Excel
        Case WM_KEYDOWN:
            Debug.Print "KeyDown"
        Case WM_KEYUP:
            Debug.Print "KeyUp"
        Case WM_LBUTTONDOWN:
            Debug.Print "LeftDown"
            Form1.Timer1.Enabled = True
        Case WM_LBUTTONUP:
            Debug.Print "LeftUp"
        Case WM_LBUTTONDBLCLK:
            Debug.Print "DblClick"
        Case WM_CAPTURECHANGED
            Debug.Print "Capture Changed"
        '...
        '...
        '-------------------------------------------------------------------
    End Select
End Function

'******************************************************************************************
